Home | History | Annotate | Line # | Download | only in ldap
      1 #!/bin/sh
      2 #
      3 # Copyright (c) 2006 - 2016 Kungliga Tekniska Hgskolan
      4 # (Royal Institute of Technology, Stockholm, Sweden). 
      5 # All rights reserved. 
      6 #
      7 # Redistribution and use in source and binary forms, with or without 
      8 # modification, are permitted provided that the following conditions 
      9 # are met: 
     10 #
     11 # 1. Redistributions of source code must retain the above copyright 
     12 #    notice, this list of conditions and the following disclaimer. 
     13 #
     14 # 2. Redistributions in binary form must reproduce the above copyright 
     15 #    notice, this list of conditions and the following disclaimer in the 
     16 #    documentation and/or other materials provided with the distribution. 
     17 #
     18 # 3. Neither the name of the Institute nor the names of its contributors 
     19 #    may be used to endorse or promote products derived from this software 
     20 #    without specific prior written permission. 
     21 #
     22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
     23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
     24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
     25 # ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
     26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
     27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
     28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
     29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
     30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
     31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
     32 # SUCH DAMAGE. 
     33 #
     34 # Id
     35 #
     36 
     37 env_setup="@env_setup@"
     38 srcdir="@srcdir@"
     39 objdir="@objdir@"
     40 
     41 . ${env_setup}
     42 
     43 EGREP="@EGREP@"
     44 
     45 R=TEST.H5L.SE
     46 
     47 port=@port@
     48 
     49 server=host/datan.test.h5l.se
     50 cache="FILE:${objdir}/cache.krb5"
     51 
     52 kinit="${TESTS_ENVIRONMENT} ../../kuser/kinit -c $cache ${afs_no_afslog}"
     53 kgetcred="${TESTS_ENVIRONMENT} ../../kuser/kgetcred -c $cache"
     54 kadmin="${TESTS_ENVIRONMENT} ../../kadmin/kadmin -l -r $R"
     55 kdc="${TESTS_ENVIRONMENT} ../../kdc/kdc --addresses=localhost -P $port"
     56 
     57 testfailed="echo test failed; exit 1"
     58 
     59 KRB5_CONFIG="${objdir}/krb5.conf"
     60 export KRB5_CONFIG
     61 
     62 # If there is no ldap support compiled in, disable test
     63 if ${kdc} --builtin-hdb | grep ldap > /dev/null ; then
     64    :
     65 else
     66     echo "no ldap support"
     67     exit 77
     68 fi
     69 
     70 #search for all ldap tools
     71 
     72 PATH=/usr/local/sbin:/usr/sbin:/sbin:/usr/libexec:/usr/lib/openldap:$PATH
     73 export PATH
     74 
     75 oldifs=$IFS
     76 IFS=:
     77 set -- $PATH
     78 IFS=$oldifs
     79 for j in slapd slapadd; do
     80   for i in $*; do
     81     test -n "$i" || i="."
     82     if test -x $i/$j; then
     83        continue 2
     84     fi
     85   done
     86   echo "$j missing, not running test"
     87   exit 77
     88 done
     89 
     90 sh ${objdir}/slapd-init || exit 1
     91 
     92 trap "sh ${srcdir}/slapd-stop ; exit 1;" EXIT
     93 
     94 rm -f current-db*
     95 
     96 > messages.log
     97 
     98 echo Creating database
     99 ${kadmin} \
    100     init \
    101     --realm-max-ticket-life=1day \
    102     --realm-max-renewable-life=1month \
    103     ${R} || exit 1
    104 
    105 ${kadmin} add -p foo --use-defaults foo@${R} || exit 1
    106 ${kadmin} add -p foo --use-defaults bar@${R} || exit 1
    107 ${kadmin} add -p kaka --use-defaults ${server}@${R} || exit 1
    108 
    109 ${kadmin} cpw --random-password bar@${R} > /dev/null || exit 1
    110 ${kadmin} cpw --random-password bar@${R} > /dev/null || exit 1
    111 ${kadmin} cpw --random-password bar@${R} > /dev/null || exit 1
    112 
    113 ${kadmin} cpw --random-password suser@${R} > /dev/null|| exit 1
    114 ${kadmin} cpw --password=foo suser@${R} || exit 1
    115 
    116 ${kadmin} list '*' > /dev/null || exit 1
    117 
    118 echo foo > ${objdir}/foopassword
    119 
    120 echo Starting kdc
    121 ${kdc} --detach --testing || { echo "kdc failed to start"; exit 1; }
    122 kdcpid=`getpid kdc`
    123 
    124 trap "kill ${kdcpid}; echo signal killing kdc; sh ${srcdir}/slapd-stop ; exit 1;" EXIT
    125 
    126 ec=0
    127 
    128 echo "Getting client initial tickets";
    129 ${kinit} --password-file=${objdir}/foopassword foo@$R || \
    130 	{ ec=1 ; eval "${testfailed}"; }
    131 
    132 echo "Getting ${server} ticket"
    133 ${kgetcred} ${server}@${R} || { ec=1 ; eval "${testfailed}"; }
    134 
    135 
    136 echo "Getting *@$R inital ticket (fail)";
    137 ${kinit} --password-file=${objdir}/foopassword '*'@$R 2>/dev/null && \
    138 	{ ec=1 ; eval "${testfailed}"; }
    139 
    140 
    141 echo "killing kdc (${kdcpid})"
    142 kill $kdcpid || exit 1
    143 
    144 trap "" EXIT
    145 
    146 # kill of old slapd
    147 sh ${srcdir}/slapd-stop
    148 
    149 rm -rf db schema
    150 
    151 exit $ec
    152